
package com.sample;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.RemoteException;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

import com.felicanetworks.falp.android.intent.FalpSendIntentListener;

public class FeliCaFalpIntentSampleActivity extends Activity implements OnClickListener {

    private FelicaIntentSender sender;
    private AlertDialog mDialog;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.falp_intent);

        Button btn1 = (Button) findViewById(R.id.btn1);

        btn1.setOnClickListener(this);

        sender = new FelicaIntentSender(this);

    }

    @Override
    public void onClick(View v) {
        Intent intent = new Intent();
        intent.setAction(Intent.ACTION_VIEW);
        intent.setData(Uri
                .parse("http://www.google.co.jp/search?q=じゅげむ じゅげむ ごこうのすりきれ かいじゃりすいぎょの すいぎょうまつ うんらいまつ ふうらいまつ くうねるところにすむところ やぶらこうじのぶらこうじ ぱいぽ ぱいぽ ぱいぽのしゅーりんがん しゅーりんがんのぐーりんだい ぐーりんだいのぽんぽこぴーの ぽんぽこなーの ちょうきゅうめいのちょうす"));

        
        SendIntentTask task = new SendIntentTask();
        task.execute(intent);
        
        // ダイアログ表示
        mDialog = new
                AlertDialog.Builder(FeliCaFalpIntentSampleActivity.this).setMessage("端末をタッチさせてください")
                        .setNegativeButton("キャンセル", new
                                DialogInterface.OnClickListener() {

                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        // キャンセルボタンが押されたら、キャンセル処理を行う
                                        sender.canceled();
                                        sender.disconnect();
                                    }
                                }).create();

        mDialog.show();

    }

    private FalpSendIntentListener listener = new FalpSendIntentListener.Stub() {

        @Override
        public void sentFalpTerminated(int arg0, int arg1) throws RemoteException {
            
            // 送信完了時呼び出し
            Log.d("sample", "送信完了");
        }

        @Override
        public void proposedInitiatorFalp() throws RemoteException {
            // 端末がタッチされた場合に呼び出される
            if (mDialog.isShowing()) {
                mDialog.dismiss();
            }
        }
    };

    class SendIntentTask extends AsyncTask<Intent, Void, Void> {

        @Override
        protected Void doInBackground(Intent... params) {
            sender.connect();
            while (!sender.isConnected()) {
                try {
                    Thread.sleep(100);
                } catch (InterruptedException e) {
                    // 無視する
                }
            }
            sender.sendIntent(listener, params[0]);
            return null;
        }
    }
}
