
package com.sample;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

import com.felicanetworks.mfc.AppInfo;
import com.felicanetworks.mfc.FelicaEventListener;
import com.felicanetworks.mfc.PushIntentSegment;
import com.felicanetworks.mfc.PushSegment;
import com.felicanetworks.mfc.PushStartBrowserSegment;
import com.felicanetworks.mfc.PushStartMailerSegment;

public class FeliCaPushSampleActivity extends Activity implements FelicaEventListener, OnClickListener,FelicaPushListener {

    private FelicaPushSender sender;

    private PushSegment mPushSegment;
    
    private AlertDialog mDialog;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.push);

        Button btn1 = (Button) findViewById(R.id.btn1);
        Button btn2 = (Button) findViewById(R.id.btn2);
        Button btn3 = (Button) findViewById(R.id.btn3);

        btn1.setOnClickListener(this);
        btn2.setOnClickListener(this);
        btn3.setOnClickListener(this);
        
        sender = new FelicaPushSender(this);
    }

    @Override
    protected void onPause() {
        super.onPause();
        try {
            sender.disconnect();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    protected void onResume() {
        super.onResume();

        try {
            sender.connect();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void errorOccurred(int id, String msg, AppInfo otherAppInfo) {

        sender.errorOccurred(id, msg, otherAppInfo);
    }

    @Override
    public void finished() {

        sender.push(mPushSegment,this);

    }

    @Override
    public void onClick(View v) {

        switch (v.getId()) {
            case R.id.btn1:
                // FeliCaPushでブラウザ起動
                String url = "http://gihyo.jp/magazine/wdpress/";
                mPushSegment = new PushStartBrowserSegment(url, null);
                break;

            case R.id.btn2:
                // FeliCaPushでメール起動
                String toAddress[] = {
                        "to@hoge.com"
                };
                String ccAddress[] = {
                        "cc@hoge.com"
                };
                String subject = "Subject";
                String body = "Body";

                mPushSegment = new PushStartMailerSegment(toAddress, ccAddress, subject, body, null);
                break;

            case R.id.btn3:
                // インテント起動
                Intent intent = new Intent(Intent.ACTION_DIAL, Uri.parse("tel:0123456789"));
                mPushSegment = new PushIntentSegment(intent);

                break;

        }

        mDialog = new AlertDialog.Builder(FeliCaPushSampleActivity.this).setMessage("端末をタッチさせてください")
                .setNegativeButton("キャンセル", new DialogInterface.OnClickListener() {

                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        sender.canceled();
                    }
                }).create();
        mDialog.show();

        sender.activate(this);
    }

    @Override
    public void finished(boolean flag) {
        mDialog.dismiss();        
    }

}
